/***   debu.c ***/

#include "lisp.h"
#include <stdio.h>
//   2020.1.1
//  for FENV  check

static ptr check_list(ptr p){
   int m;
  m=ATTR(p);
  if(m==CELL){
    check_list(CAR(p));
    check_list(CDR(p));
  }
  else{
    if(m&FREECELL)
       fprintf(stderr,"Abnormal free  cell %p attr=%x\n",p,m);
    else if(m&GBCMARK)
       fprintf(stderr,"Abnormal GBCMARK is set cell %p  attr=%x\n",p,m);
    else if((p==a_nil)&&(m!=NILL))
       fprintf(stderr,"Abnormal nil %p  attr=%x\n",p,m);
    else
      ;
  }
 return a_nil;
}

ptr check_func(ptr f,int attr){
  ptr q;
  int m;
    q=FENV(f);
    m=ATTR(q);
    if(m==SYMBOL) return q;
    return check_list(q);
}

ptr s_check_f(int narg,ptr env){  //(check-f f)
 Reg ptr x,y;
  int n;
   if(narg!=1) return a_f;
   x=*(stack-1);
   n=ATTR(x);
  if((n&CLOSURE)==0) return a_f;
  return check_func(x,n);
} 

