/*** readl.c  **/
/***  created 03.10.27  ***/

#include "lisp.h"
#include <stdio.h>

extern char linebuff[];
extern int linepos;
extern ptr makestring_p();
extern void simple_line_get(void);

static ptr wstr_port=0;

/***   win 0d0a , unix 0a,  Mac 0d ***/ 

static ptr read_line(ptr lpath){
 ptr c,res,wpath,newline,cr,debug;
char ch;
int n=0;
  newline=MAKECHAR('\n');
  cr=MAKECHAR('\r');
  if(lpath==a_keyinput){
       simple_line_get();
       if(linepos==0) return SEOF;
       ch=linebuff[--linepos];
       if(ch!='\n') linepos++;
       res= GMAKESTR(linebuff,linepos);
       linepos=0;
       return res;
   }
  if(wstr_port){
     //printf("read_line reopen\n");
    wpath=reopen_str(wstr_port,0);
  }
 else{
    // debug
    psh(a_nullstr);
     wstr_port=wpath=s_str_output(1,a_nil);
     sysprotect[syspro++]=wstr_port;
     //debug=CDDR(CDDR(wpath));
     //printf("read_line called first cdddr(wport)=%p  malloc %p\n",debug,CAR(debug));
    pull();
 }
 while(1){
    c=read_char(lpath);
    /*** printf("read-line %x %c\n",c,CHAR_CODE(c)); ***/
    if(c==SEOF||c==newline) break;
    if(c==cr){  /***  win or mac ***/
       c=read_char(lpath);
       if((c!=newline)&&(c!=SEOF)) unreadchar(c,lpath);
       c=newline;
       break;
    }
      writechar(c,wpath);
       n++;
 }   
  /*** res=s_close(1,a_nil);
  pull();
  ***/
  res=close_str(wpath);
 if(n||c==newline){
    return copy_str(res);
  }
 return SEOF;
}

ptr s_read_line(int narg,ptr env ){
 ptr lpath;
  if(narg==0) lpath=STDIN;
  else if (narg==1) lpath=*(stack-1);
  else checknarg(narg-1);
  return read_line(lpath);
}

