;;; out-linear.ss
;;;       see  exp-linear.ss
;;;     for MACRO  template output
;;;  2005.10.17
;;;;


(define (exp->outlinear exp)
  (let* ((res (exp->out-main exp)))
    (if (pair? res)
            res
         (list res )
    )
))
         
(define (exp->out-main  exp)
   (if (pair? exp)
      (let* ((tmp (cons () ())))
          (exp->out-sub exp tmp)
          (cdr tmp)
      )
      exp
    )
)

(define (exp->out-sub exp tmp)
 (let* ((x (car exp)))
   (if (symbol? x)
       (cond ((eq? x '...)
                 (set! x (exp->out-main (cadr exp)))
                 (set-cdr! tmp (cons (list '... x )()))
                 (cdr tmp)
              )
             ( (eq? x 'vector)
                  (set-cdr! tmp (cons '(S-write-vector-left) ()))
                  (set! tmp (cdr tmp))
                  (set! exp (cdr exp))   ;;; skip vector
                  (set! tmp (exp->out-pair exp tmp))
                 (set-cdr! tmp (cons '(S-write-vector-right) ()))
                 (cdr tmp)
               )
             (else
                 (set-cdr! tmp (cons exp ()))
                  (cdr tmp)
             )
        )
     (begin
         (set-cdr! tmp (cons '(S-write-left) ()))
         (set! tmp (cdr tmp))
         (set! tmp (exp->out-pair exp tmp))
         (set-cdr! tmp (cons '(S-write-right) ()))
         (cdr tmp)
      )
   )
))

(define (exp->out-pair exp tmp)
   (let* ((x 0))
     (while (pair? exp)
             (set! x (pop exp))
             (if (pair? x)
                  (set! tmp (exp->out-sub x tmp))
                   (begin
                       (set-cdr! tmp (cons x ()))
                       (set! tmp (cdr tmp))
                   )
             )
     )
   tmp
))


