;;;;  regexp-nfa 
;;;;   V2.0   with bug
;;;;   2010.8.14
;;;   fixed by this file
;;;;   Why we need this?


;;;(g "R-nfaexec")   The following is a part of R-nfaexec.ss
;;;
(in-package "regexp")
(define  (regexp-nfa  state )
 (let* ((trans  (Rstate state))(stack (list trans))(kstack '(()))
           (A 0) (op 0)(orgstate state) )
  (while (and state (pair? stack))
     (set! trans (pop stack))
     ;;;(format #t "nfa  trans ~s stack ~s ~%" trans  stack)
    (when (not (eq? trans 0))
         (set! trans  (get-trans trans))
       (when (not (eq? trans 0))
               (set! A (car trans))
             ;;; (format #t "main trans ~s   car  ~s ~%" trans A)
         (cond ( (symbol? A)
                   (set! state (regexp-nfa-atom trans state)))
               ( (number? A)
                   (push (cdr trans) stack)
                   (push A stack)
               )
       ;;; ((:or C D))  A=(:or C D)   etc.
           (else 
              (set! op (car A))
              (cond ((eq? op :or)
             ;;; (format #t "regexp-exec: or A ~s ~%" A)
                       (push (caddr A) stack) 
              ;;;(format #t "regexp-exec: stack  ~s ~%" stack)
              ;;;;   push-state causes a bug, Why?
              ;;;;
                       (push-state state stack)
              ;;;;(format #t "regexp-exec: stack 2  ~s ~%" stack)
                       (push :or stack)
                       (push stack kstack)
                       (push  (cadr A) stack)
              ;;(format #t "or state  ~s   stack  ~s ~%" state stack)
                       )
                    ((eq? op :forward)
                       (push-Rindex state stack)
                       (push op stack)
                       (push stack kstack)
                       (push  (cadr A) stack)
                     )
                    (  (eq? op :not)
                       (push-state state stack)
                       (push op stack)
                       (push stack kstack)
                       (push  (cadr A) stack)
                     )
                    ((eq? op :if)
                        (set! kstack (nfa-if (cdr A) state stack kstack))
                        (set! stack (pop kstack))
                      )
                (else
                     (error 543 A)
                )
              )
           )
         )
      )
     )
     (if state
          (when (and  (pair? stack) (eq? stack (car kstack)))
             (set! kstack (key-true-stack state stack kstack))
             (set! state (pop kstack))
             (set! stack (pop kstack))
          )
          (begin
             (set! kstack (key-false-stack orgstate stack kstack))
             (set! state (pop kstack))
             (set! stack (pop kstack))
          )
     )
  )
 state
))
(define  (key-false-stack orgstate stack kstack)
  (let* ((state #f)(op 0))
        (set! stack (pop kstack))
        (when (pair? stack)
            (set! op (pop stack))
            (cond ((eq? op :or)
             ;;; (format #t ":or  try to second   stack  ~s ~%" stack)
                          (set! state (pull-state orgstate stack))
                    )
                  ((eq? op :not)
                      (set! state (pull-state orgstate stack))
                    )
                  ((eq? op :forward)
                      (pull-Rindex orgstate stack)  ;;;; still false
                    )
                  ((eq? op :if)
                      (set! state (pull-state orgstate stack))
                      (pop stack)  ;;; throw then
                    )

              (else (error 413 op))
          )
        )
        (if state
            (if (and (pair? stack)(eq? stack (car kstack))) 
                   (key-true-stack state stack kstack)
                   (cons  state (cons stack kstack))
            )
            (if (pair? kstack)
                (key-false-stack orgstate stack kstack)
                (cons  state (cons stack kstack))
            )
        )
))
;;;  regexp2.0
;;;   2005.8.19
;;;
;;;  reduce rules
;;;   :e  == epsilon transition
;;;  


;;;
;;;(init-R-debug)  This is the following
(set! *nfa-function* regexp-nfa)
