(in-package "macro")

(define (syntax-ex f )
  (if (pair? f)
        (syntax-ex-pair f)
      (begin   ;;; allow symbol-transformer see P.193
         (if (symbol? f)
           (let* (( x ())(flag 0)(ex 0))
              (if (syntax-symbol? f) (set! f (change-syntax-symbol f)))
              (set! x (macro? f))
              (if  x 
                 (begin
                   (set! flag (syntax-single? x))
                   (if (and flag (not (eq? flag #t))) ;;; unchecked
                     (begin
                      (set! flag (catch 
                        (set! ex (sys-eval (list x (list quote f)) *local-env*))
                        ))
                      (if flag
                          (begin (syntax-single x #f) f)  ;;; checked and not allow
                          (begin (syntax-single x #t) ex)  ;;; checked and allow
                      )
                    )
                  ;;; (format #t "singlton macro:~s ~s~%" f x)
                   (if flag
                        (sys-eval (list x (list quote f)) *local-env*)
                        f
                   ) ))  ;;;end begin
                 f
              ) )  ;; end let*
           f
         )
      )
  )
)
#|
(in-package "ss")

(define (errorhook enum obj)
   (if (eq? enum E_identifiersyntax)
     (begin
        (print-error enum obj)
        #t  ;;;; means to top-level
     )
    #f ;;;;  continue  error process 
  )
)
|#
   
