;;;  write-loop-list.ss
;;;;   loop list output utility
;;;  experimental
;;; 07.1.20

(define *loop-list* ())
(define *all-ptr* ())
(define *label* 0)

(define (make-loop-list s)
  (let*  ((all ()))
    (set! *loop-list* ())
    (set! *all-ptr* ())
    (set! *label* 0)
    (push (cons s 0) *all-ptr*)
    (inc *label*)
    (make-loop-aux (car s) )
    (make-loop-aux (cdr s) )
))

(define  (make-loop-aux s )
   (if (pair? s)
      (let* ((c  (assq s *all-ptr*)))
         (if c
             (when (not  (assq s *loop-list*))
                  (push c *loop-list*)
             )
            (begin
               (push (cons s *label*) *all-ptr*)
                 (inc *label*)
               (make-loop-aux (car s) )
               (make-loop-aux (cdr s) )
            )
        )
      )
   )
)

(define  (write-list-form s)
   (make-loop-list s)
   (if (null?  *loop-list*)
        s
       (begin
         (set! *all-ptr* ())
         (infinity-list-form s)
       )
    )
)

(define  (infinity-list-form s)
   (let* ((c (assq s *loop-list*)))
      (if c
        (if (assq s *all-ptr*)
           (list 'LB= (cdr c))
           (begin
             (push c *all-ptr*)
             (list 'DEF-LB (cdr c) (cons (infinity-list-form (car s))
                                ( infinity-list-form (cdr s))))
           )
        )
       (if (pair? s)
           (cons (infinity-list-form (car s))
                                ( infinity-list-form (cdr s)))
           s
       )
    )
))
       

