
(canvas '.can :width 350 :height 350 :borderwidth 5 :highlightthickness 8)
(image 'create 'photo 'dolphin  :file "dolphin3.gif")
(.can 'create 'image 10 10 :image dolphin :anchor 'nw )
(pack .can)

(image 'create 'photo 'ic  :file "ic_icon.gif")
(.can 'create 'image 20 20 :image ic :anchor 'nw  :tag  'pic1)
(.can 'create 'image 100 70 :image ic :anchor 'nw  :tag  'pic2)

(define *d1*  #(3 3))
(define *d2*  #(-3 3))

(define (move tag vec)
  (let* ((box (.can 'bbox tag)) (x (car box))(y (cadr box)) (dx 0) (dy 0)) 
     (set! dx (vector-ref vec 0))
     (set! dy (vector-ref vec 1))
     (cond  ((< x 0) (set! dx 3))
            ((> x 300) (set! dx -3))
            ((< y 0) (set! dy 3))
            ((> y 300) (set! dy -3))
     )
     (.can 'move tag dx dy)
     (vector-set! vec 0 dx)
     (vector-set! vec 1 dy)
))


(define (start )
   (move 'pic1 *d1*)
   (move 'pic2 *d2*)
   (after 100 '(start))
)

(after 3000 '(start))

