/***  formsub.c
***/

#include "lisp.h"
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
/*   format.c start */
/****   format.c separated to
     format.c  formsub.c   ****/

//#define  display(x,stream)  princ(x,stream)     /* 2014.9.12*/
#define PAGE 12      // FF
 

#define atto  (modeb&2)
/** extern int col_loc[];    89.7.26 */
extern ptr _float();
extern int get_pos(ptr);
extern char *Prin_sint(Long,int,char *);
extern char *Prin_uint(ULong,int,char *);
extern void prin_E(double,int,char *);

extern ptr para_ref();  /**2014.9.13**/
extern void form_err(int,ptr); 
extern ptr fmopen(void),fmclose(void);

/*** #define pos(s)  POS_OUT(s)   col_loc[n]  position not support for ss ***/

extern void pad(ptr pad_c,int n ,ptr stream);
//extern  char f_format[12];
static char sisu[50];    //   will be delete !

#define MAXK  15   /***  53 bit < 16 keta ****/

static char xf[64],wf[64],vf[64];  // 22 is enough
static int val_sisu,yuuko;
static double f_val;
char *zerot(),*marume();
/*** New 2014.9.13   ***/
ptr char_space;
void formD_exec(ptr x,ptr stream,ptr para,ptr mode,int radix);
void formD_sub(ptr x,int w ,ptr stream,ptr para,ptr mode,int radix);
void formR_cardinal(ptr x,ptr stream);
void formR_cardinal_aux(ptr  x,int  keta,ptr stream,int  len,int lion);
void formR_japanese(ptr x,ptr stream);
void formR_japanese_aux(ptr  x,int keta,ptr stream);
void formR_japanese_aux_exe(ptr  x,int keta,ptr stream,int len,int lion);
void formR_ordinal(ptr x ,ptr stream);
void formR_ordinal_aux(ptr  x,int  keta,ptr stream,int  len,int lion);
int f_init(ptr);
//int f_init_set(ptr);
int makesisu(char *,int,int);

ptr check_CAR(ptr args){
    if(CONSP(args)) return CAR(args);
   form_err(E_fm_arg,args);
   return a_nil;  //Never
}

/*   get string by radix  */
//  base 2~36
//   for signed 64 bit int  print
//

void R_display( ptr x,int  radix,ptr stream){
  int m;
  ptr base,prad;
  base=ATOMVAL(print_radix);
  prad=MAKESINT(radix);
      m= (base !=prad);
       if( m){
           ATOMVAL(print_radix)=prad;
          //print_base=radix;
      }
     princ( x ,stream);
    if(m){
           ATOMVAL(print_radix)=base;
        //print_base=m;
     }
}
/**   get string by radix  **/
ptr R_string( ptr  x,int  radix){
     ptr  out;
       out=fmopen();
       R_display ( x, radix,out);
       return fmclose();  //return string
}

int para_num(ptr para,int ind,int  def){
     ptr x;
      x= para_ref( para, ind);
     if(x!=a_f){
        if(SINTP(x)) return GETNUM(x);
          form_err( E_fm_int,x);
        }
    return   def;
}

int para_char(ptr  para,int ind,int def){
     ptr x;
      x= para_ref( para, ind);
     if(x!=a_f){
        if  (CHARP(x)) return CHAR_CODE(x);
             
             form_err( E_fm_char, x);
       }
    return   def;
}

ptr para_pchar(ptr  para,int ind,ptr def){
     ptr x;
      x= para_ref( para, ind);
     if(x!=a_f){
        if  (CHARP(x)) return x;

             form_err( E_fm_char, x);
       }
    return   def;
}


void fresh_line(ptr stream){
  if (get_pos( stream))
    WRITE_CHAR('\n', stream);
}

void formTab(ptr stream,ptr para,ptr mode);
void formSA( int wf, ptr x,ptr stream,ptr para,ptr mode);
ptr formARG(ptr args,ptr para,ptr mode,ptr orgargs );
ptr formPlural(ptr args,ptr stream,ptr  para,ptr mode,ptr orgargs);
void formD(ptr x,ptr stream,ptr para,ptr mode,int radix);
void formR(ptr x,ptr stream,ptr para,ptr mode );
void formF(ptr x,ptr stream,ptr para,ptr mode);
void formE(ptr x,ptr stream,ptr para,ptr mode);
void formG(ptr x,ptr stream,ptr para,ptr mode);
void formDC(ptr x,ptr stream,ptr para,ptr mode);
void formAC(ptr x,ptr stream,ptr para,ptr mode);


ptr  format_out_simple(ptr stream,ptr c,ptr para,ptr mode,ptr  args,ptr orgargs){
   ptr x,w;
   int code,n,radix;
        w=para_ref( para, 0);
      //fdebug(para,8);
        code=CHAR_CODE(c);
    switch(code){
       case 's': 
             x=check_CAR(args);
             args=CDR(args);
             if  (SINTP(w))
                 formSA( 1, x ,stream, para, mode);
             else
                 prin1( x ,stream);
             break;
      case 'a':
             x=check_CAR(args);
             args=CDR(args);
             if  (SINTP(w))
                 formSA( 0, x ,stream, para, mode);
             else
                 princ( x ,stream);
            break;
      case '%': 
                 x=MAKECHAR('\n');
             if  (SINTP(w))
                 pad( x,GETNUM(w), stream);
            else
                 princ(x, stream);
             break;
      case '|':
                 x=MAKECHAR(PAGE);
             if  (SINTP(w))
                 pad( x,GETNUM(w), stream);
            else
                 princ(x, stream);
            break;
      case '&':
                 fresh_line(  stream);
             if  (SINTP(w)){
                 x=MAKECHAR('\n');
                    n=GETNUM(w);
                   n--;
                 pad( x,n, stream);
             }
            break;
       case 't':   //tab
                 formTab(stream, para, mode);
                break;
       case '\n':      //  #\newline)   ;;;  P.596
              if (mode==TWO) princ(MAKECHAR('\n'), stream);
              break;
       case  '~':
                    x=MAKECHAR('~');
             if  (SINTP(w))
                 pad( x,GETNUM(w), stream);
            else
                 princ(x, stream);
             break;
       case 'b':radix=2;
                goto Fix;
       case 'o':radix=8;
                goto Fix;
       case 'x':radix=16;
                goto Fix;
       case 'd':radix=10;
            Fix:
               x=check_CAR(args);
               formD(x, stream, para, mode, radix);
               args=CDR(args);
              break;

       case 'r':
               x=check_CAR( args);
               args=CDR(args);
             if  (INTEGERP(x))
                 formR(  x ,stream, para, mode);
             else{
                 if(para!=a_nil)
                    formAC(  x,stream,CDR(para),mode); // ~wA
                 else
                    princ(x, stream);
              }
              break;
      case '*':
              args=formARG(  args,  para, mode, orgargs );
             break;
      case 'p': 
              args=formPlural(  args, stream,  para, mode, orgargs );
           break;
      case 'c':   //  Only write-char
               x=check_CAR( args);
               args=CDR(args);
             if (CHARP( x))
                 prin1( x, stream);
             else
                 form_err( E_fm_type, c);
           break;
      case 'e': 
               x=check_CAR( args);
              formE(x,stream, para, mode);
               args=CDR(args);
           break;
      case 'f':
               x=check_CAR( args);
              formF(x,stream, para, mode);
               args=CDR(args);
           break;
      case 'g':
               x=check_CAR( args);
              formG(x,stream, para, mode);
               args=CDR(args);
           break;
      case '$':
               x=check_CAR( args);
              formDC(x,stream, para, mode);
               args=CDR(args);
           break;

      default:
            form_err( E_fm_directive, c);
      }
    return args;
}
void formTab(ptr stream,ptr para,ptr mode){
   int s,colnum,colinc,pos,modeb;
   ptr sp=char_space;

   colnum=para_num( para, 0 ,1);
   colinc=para_num( para, 1, 1);
   pos=get_pos(stream);
     if(mode==ZERO){
              if (pos< colnum)
                    pad(sp, colnum- pos, stream);
              else{
                 if (colinc> 0){
                     s =colnum- pos;  // <= 0
                     while (s<= 0)
                        s+= colinc;
                    pad(sp, s, stream);
                 }
             }
           }
    else if(mode==TWO){    // @t relative  tab
                    pad(sp, colnum, stream);
                  pos+= colnum;
               if (colinc> 0){
                    s= pos% colinc;
                   if (s> 0)
                    pad(sp, colinc-s, stream);
               }
         }
    else form_err( E_fm_mode, mode);
  }

void formS(  ptr x,ptr stream,ptr para,ptr mode){
      formSA( 1, x ,stream, para, mode);
}

void formAC(  ptr x,ptr stream,ptr para,ptr mode){
     /***  For complex number print ***/
     if((para!=a_nil)&&SINTP(CAR(para))){
       para=SCONS(CAR(para),a_nil);  // Only w
       psh(para);
      formSA( 0, x ,stream, para, ZERO);  //~wA
      pull();
     }
    else
      princ(x,stream);
}

void  formSA(int  wf,ptr x,ptr stream,ptr para,ptr mode){
   ptr str,out,pad_c;
   int w=0,n, minpad,colinc;
   //,pad_char,
   int modeb;
    //already checked not a_f
   w=GETNUM(para_ref( para, 0));
   if(w==0){
         if(wf)
            prin1(x,stream);
         else
            princ(x,stream);
         return;
   }
      out=fmopen();
    if(wf)
          prin1(x,out);
    else
          princ(x,out);
      x =fmclose();
     psh(x);//!!!
      n= STRLEN(x);
      if (n>= w)
             princ( x, stream);
      else{
            wf=1;
            minpad =para_num( para, 2, 0);  
            pad_c= para_pchar( para, 3, char_space);  // pad-char
            //pad_c=MAKECHAR(pad_char);
            w= w- n;
            modeb=GETNUM(mode);
            if ((modeb& 2)==0){     // not @
                princ( x, stream);
                wf=0; 
            }
            if(minpad>0){
              pad( pad_c, minpad, stream);
              w-=minpad;
            }
           if ( w>0){
                colinc=para_num( para, 1, 1);
                if (colinc<= 1)
                   pad( pad_c, w, stream);
                else{
                  while( w> 0){
                     pad( pad_c, colinc, stream);
                     w-= colinc;
                  }
               }
            }
            if(wf) princ( x, stream);  //  @  right
      }
    pull();  //!!!
  }

/**  ~*  args ignore or backup   P.598  **/
ptr  goto_args(int w,ptr args){
     if ( w< 0) form_err( E_fm_backup, args);
     while (w> 0){
        args=CDR (args);
        w--;
     }
   return args;
}

ptr  backup_args(int w,ptr args,ptr orgargs){
   return goto_args(  nc_length( orgargs)- w- nc_length( args), orgargs);
}


ptr formARG(ptr args,ptr para,ptr mode,ptr orgargs ){
    ptr wp;
    int w;
    wp= para_ref( para, 0);
      if( mode==ZERO ){   // ignore w args
               if (wp==a_f)  w=1;
               else  w=GETNUM(wp);
               return goto_args( w ,args);
            }
      else if(mode==ONE){   // backups w args
               if (wp==a_f)  w=1;
               else  w=GETNUM(wp);
               return backup_args( w, args, orgargs);
            }
     else if( mode==TWO){   // absolute goto  w-th args
               if (wp==a_f)  w=0;
               else  w=GETNUM(wp);
               return goto_args( w ,orgargs);
            }
     else 
         form_err( E_fm_mode, mode);
    return a_f;//Never
  }

/**  ~P   with backup args  **/
ptr formPlural(ptr args,ptr stream,ptr  para,ptr mode,ptr orgargs){
  ptr x;
  int modeb;
  modeb=GETNUM(mode);
    if( (modeb& 1)== 1)
               args= backup_args( 1, args, orgargs);
    
    x= CAR( args);
    args=CDR(args);
     if(x==ONE){
         if (( modeb& 2)== 2)
                     princ(MAKECHAR('y'), stream);
      }
     else{
         if (( modeb& 2)== 2)
            pr_cstr(stream,"ies");  //lisp.h , stream.c
         else            
            princ(MAKECHAR('s'), stream);
     }
  return args;
}
/***   ~w,padc,commac,keta D
      keta=3 default
***/
void  formD(ptr x,ptr stream,ptr para,ptr mode,int radix){
  int m;
  ptr base,prad;
  base=ATOMVAL(print_radix);
  prad=MAKESINT(radix);
  //b=print_base;
  m= ( base!= prad);
           if(m){ 
                ATOMVAL(print_radix)=prad;
                //print_base=radix;
           }
          if(INTEGERP(x))
                 formD_exec(x, stream, para, mode, radix);
          else{
           formAC(x,stream,para, mode);  //~wA
             // princ( x, stream);     
          }
             
       if(m) {
                ATOMVAL(print_radix)=base;
              //print_base=m;
      }
}


 void formD_exec(ptr x,ptr stream,ptr para,ptr mode,int radix){
     int w;
      w=para_num(para, 0, 0);
      if (nc_length( para)> 2) mode=(ptr)((long)mode| 4);  // logior 1, Caution!!  , comma-char even if #f
      if ((mode==ZERO)&& (w== 0))
             princ( x ,stream);
      else
            formD_sub( x , w ,stream ,para, mode, radix);
  }

ptr comma_sepa(ptr x, int keta,int sigchar,ptr comma);

ptr formD_aux(ptr x,int sig,ptr comma,int  keta){
     int sigchar= sig;
     ptr out;
       out=fmopen();
       if(gsign(x))    // f_math.c
           sigchar='-';
       else if (sig)
                princ(MAKECHAR('+'),out);
       else
         ;
       princ (x ,out);
       x=fmclose();
       if(comma){
           psh(x);
           x= comma_sepa( x, keta, sigchar, comma);
           pull();
       }
   return x;
}

ptr comma_sepa(ptr x, int keta,int sigchar,ptr comma){
   ptr c,cnext,in,out,sig;
   int len,pos;
   len=STRLEN (x);
   pos=  (len- 1)% keta;
   sig=MAKECHAR(sigchar);
  in= open_str(x,read_ac);
    c= read_char(in);
    out=fmopen();
    while (c!=SEOF){
       princ (c,out);
       cnext= read_char( in);
       if ((pos== 0) &&(c!= sig)&&(cnext!=SEOF))
           princ( comma, out);
       
       if (pos== 0)
              pos= keta- 1;
       else
           pos--;
       
      c= cnext;
   }
  sys_close(in);
  return fmclose();
}

void pad_comma(int w,int n,int keta,ptr zero,ptr comma,ptr pad_c,ptr stream);
ptr formD_aux(ptr x,int sig,ptr comma,int  keta);

void formD_sub(ptr x,int w ,ptr stream,ptr para,ptr mode,int radix){
   int n,pad_char,modeb;
    int sig=0,keta;
    ptr  pad_c,comma,zero;
    modeb=GETNUM(mode);
      if  ( (modeb& 1)== 1){   //  :D or comma is given
            comma=para_pchar( para, 2,MAKECHAR(','));
            keta=para_num(para, 3, 3);  //  default =  3
       }
       if ((modeb& 2)==2)  // @D
           sig='+';
      
      x= formD_aux( x, sig, comma, keta);
      psh(x); //!!
       n= STRLEN( x);
     // (format #t "formS w=~s x=~s mode ~a ~%" w x  mode)
       if (n>= w)
           princ( x, stream);
       else{   
            pad_c= para_ref( para, 1);  //  pad-char
            w-= n;
            if (w> 0){
                if ((!sig)&&((modeb> 3)||(radix!= 10))&&comma&& (pad_c==a_f)){
                      pad_c=char_space;
                      zero=MAKECHAR('0');
                     pad_comma( w, n, keta, zero, comma, pad_c, stream);
                   }
                else{
                      if (pad_c==a_f) pad_c=char_space;
                      pad( pad_c, w, stream);
                   }
            }
            princ( x ,stream);    //  @  right
         }
    pull();      
}

void pad_comma(int w,int n,int keta,ptr zero,ptr comma,ptr pad_c,ptr stream){
   int keta1= 1+ keta;
   int pos;
   pos= (w+ n)% keta1;
     while (w> 0){
        if ( pos== 0){
             if (pad_c!=a_f)
               princ( pad_c, stream);   // only at TOP
             else
               princ( comma, stream);
         }
        else
              princ( zero, stream);
        pad_c=a_f; 
         w--;
        pos--;
       if(pos< 0) pos+= keta1;
   }
}
/***
;;;   ~radix,w,padc,commac,keta R
;;;     keta=3 default
;;;
***/
void formR_roman (ptr x ,ptr stream);

void formR(ptr x,ptr stream,ptr para,ptr mode ){
  ptr radix;
  int modeb,base;
    radix= para_ref( para, 0);
    modeb=GETNUM(mode);
      if( radix!=a_f||para!=a_nil){
          if(radix==a_f)
               base=10;
          else
               base=GETNUM(radix);
          para= CDR( para);  //  shift in para-list!
          formD(   x, stream, para, mode,base);
        }
      else{
        switch(modeb){
              case 0: formR_cardinal( x ,stream);
                      break;
              case 1: formR_ordinal ( x, stream);
                      break;
              case 2: 
              case 3: formR_roman(x, stream);
                      break;
             default: formR_japanese(    x, stream);
       }
    }
}
char *Lion[]={"", "thousand ", "million ", "billion ", "trillion ", "quadrillion "};  //[6]

char *Cardinal_base[]={" ", "one ", "two ", "three ", "four ", "five ", "six ", "seven ", "eight ", "nine "};//[10]

char *Cardinal_tenover[]={" ", "ten","twent","thirt","fort","fift","sixt","sevent","eight","ninet"};//[10]

char *Cardinal_teen[]={"ten ","eleven ","twelve ","thirteen ","fourteen ","fifteen ","sixteen ","seventeen ","eighteen","nineteen "};  //[10]

char *cardinal_base(ptr c){
   int s;
      s= CHAR_CODE(c)-'0';
      return Cardinal_base[s];
}

char *cardinal_tenover(ptr c){
   int s;
      s= CHAR_CODE(c)-'0';
      return Cardinal_tenover[s];
}

char *cardinal_teen(ptr c){
   int s;
      s= CHAR_CODE(c)-'0';
      return Cardinal_teen[s];
}

void formR_cardinal(ptr x,ptr stream){
   char *sign=NULL;
   int len, lion;
    if(gsign(x)){
       sign= "minus ";
       x=minus (x);  //f_math.c
    }
   if (x==ZERO)
            pr_cstr(stream,"zero ");  //lisp.h , stream.c
   else{
         psh(x);  //!!!
         x= R_string( x ,10);
         *(stack-1)=x;
         len=STRLEN(x);
         lion=(len- 1)/ 3;
            if ( lion<6) {        // (vector-size Lion)!!!
                if( sign!=NULL) pr_cstr(stream,sign);
                formR_cardinal_aux ( x ,3 ,stream, len, lion);
              }
            else{
                if( sign!=NULL) pr_cstr(stream,"-");
                  princ( x ,stream);
             }
        pull();
     }
}

void formR_cardinal_aux(ptr  x,int  keta,ptr stream,int  len,int lion){
    ptr in,c; 
    int pos;
      pos= (len- 1)% keta;
     in =open_str( x,read_ac);
     psh(in);
     c =read_char( in);
    while (c!=SEOF){
       switch(pos){
         case 0:
               pr_cstr(stream,cardinal_base(c));
               pr_cstr(stream, Lion[ lion] );
               lion--;
               break;
         case  1:
              switch(CHAR_CODE(c)){
                   case '0': break;
                   case '1':
                         c =read_char( in);
                         pr_cstr(stream,cardinal_teen(c));
                         pr_cstr(stream, Lion[ lion] );
                         lion--; 
                         pos--;
                        break;
                   default:
                         pr_cstr(stream,cardinal_tenover(c));
                         c =read_char( in);
                            princ (MAKECHAR('y'), stream);
                         if (c==MAKECHAR('0'))
                             princ (char_space, stream);
                         else
                             princ (MAKECHAR('-'), stream);
                         unreadchar (c, in);
                       
               }
              break;
          case  2:
               if(c!=MAKECHAR('0')){
                  pr_cstr(stream,cardinal_base(c));
                  pr_cstr(stream, "hundred " );
               }
              break;
           default:   // Not appear
               break;
        }
       pos--;
       if (pos< 0) pos+=keta;
       c= read_char (in);
   }
  sys_close(in);
   pull();
}


char *Ordinal_base[]={"th ","first ","second ","third ","fourth ","fifth ","sixth ","seventh ","eighth ","ninth "};

char *Ordinal_teen[]={"tenth ", "eleventh ", "twelfth ", "thirteenth ", "fourteenth ", "fifteenth ", "sixteenth ",
   "seventeenth " , "eighteenth ", "nineteenth "};

char *ordinal_base(ptr c){
   int s;
      s= CHAR_CODE(c)-'0';
      return Ordinal_base[s];
}
/***
char *ordinal_tenover(ptr c){
   int s;
      s= CHAR_CODE(c)-'0';
      return Ordinal_tenover[s];
}
***/
char *ordinal_teen(ptr c){
   int s;
      s= CHAR_CODE(c)-'0';
      return Ordinal_teen[s];
}

void formR_ordinal(ptr x ,ptr stream){
  char *sign=NULL;
   int len, lion;
    if(gsign(x)){
       sign="minus ";
       x=minus (x);
    }
   if (x== ZERO)
         pr_cstr(stream,"zeroth ");
   else{
         psh(x);  //!!!
         x= R_string( x ,10);
         *(stack-1)=x;
         len=STRLEN(x);
         lion=(len- 1)/ 3;
            if ( lion<6) {        // (vector-size Lion)!!!
                if( sign!=NULL) pr_cstr(stream,sign);
                formR_ordinal_aux ( x ,3 ,stream, len, lion);
              }
            else{
                if( sign!=NULL) pr_cstr(stream,"-");
                princ( x ,stream);
                pr_cstr(stream,"th ");
             }
        pull();
     }
}
void formR_ordinal_aux(ptr  x,int  keta,ptr stream,int  len,int lion){
    ptr in,c;
    int pos,th=0;
      pos= (len- 1)% keta;
     in =open_str( x,read_ac);
     c =read_char( in);
    while (c!=SEOF){
       switch(pos){
         case 0:
               if(lion==0){
                    pr_cstr(stream,ordinal_base(c));
                    th=1;
               }
               else
                    pr_cstr(stream,cardinal_base(c));
               pr_cstr(stream, Lion[ lion] );
               lion--;
               break;
         case  1:
              switch(CHAR_CODE(c)){
                   case '0': break;
                   case '1':
                         c =read_char( in);
                         if(lion==0){
                            pr_cstr(stream,ordinal_teen(c));
                            th=1;
                         }
                         else
                            pr_cstr(stream,cardinal_teen(c));
                         pr_cstr(stream, Lion[ lion] );
                         lion--;
                         pos--;
                        break;
                   default:
                         pr_cstr(stream,cardinal_tenover(c));
                         c =read_char( in);
                         //   princ (MAKECHAR('y'), stream);
                         if (c==MAKECHAR('0')){
                            if(lion==0){
                            pr_cstr(stream,"ieth");
                               th=1;
                             }
                            else
                               princ (MAKECHAR('y'), stream);
                         }
                         else{
                             princ (MAKECHAR('y'), stream);
                             princ (MAKECHAR('-'), stream);
                         }
                         unreadchar (c, in);

               }
              break;
          case  2:
               if(c!=MAKECHAR('0')){
                  pr_cstr(stream,cardinal_base(c));
                  pr_cstr(stream, "hundred " );
               }
              break;
           default:   // Not appear
               break;
        }
       pos--;
       if (pos< 0) pos+=keta;
       c= read_char (in);
   }
  if(!th)   pr_cstr(stream, "th " );
}

/****  Roman   ***/
int Roman[]={1 ,5 ,10, 50, 100, 500, 1000,0};  //[7+1]
char  Roman_C[]="IVXLCDM";                   //[7]
int Roman_ext[]={  4, 9, 40, 90, 400, 900,0};   //[6+1]
char *Roman_ext_C[]={ "IV" ,"IX", "XL", "XC", "CD" ,"CM"}; //[6]

int take_max_ind( int roman[],int x){
    int i=0,m,max=0,ind=-1;
     m=roman[i];
   while ((m<=x)&&(m>0)){
       max= m;
       ind=i;
       i++;
       m=roman[i];
   }
  return ind;
}

void formR_roman_aux(int  x,ptr  stream);

void formR_roman (ptr x ,ptr stream){
   int n;
  if (SINTP(x)){
        n=GETNUM(x);
      if((n>0)&& ( n< 4000)){ 
        formR_roman_aux ( n,stream);
        return;
      }
   }
  princ( x, stream);
}

void formR_roman_aux(int  x,ptr  stream){
   int ir,ir2,r,r2=0;
      ir=take_max_ind(Roman, x);
      r=Roman[ir];
      ir2=take_max_ind(Roman_ext, x); //may be -1
      if(ir2>=0) r2=Roman_ext[ir2];
     if (r> r2){
          princ (MAKECHAR(Roman_C[ir]), stream);
          x-= r;
          if (x> 0) formR_roman_aux( x ,stream);
       }
     else{
          pr_cstr(stream,  Roman_ext_C[ir2]);
          x-= r2;
          if (x> 0) formR_roman_aux( x ,stream);
    }
}

void formR_japanese(ptr x,ptr stream){
    if (gsign(x)){
       pr_cstr(stream,"負" );
       x=minus(x);
    }
   if (x==ZERO)
         pr_cstr(stream,"零");
   else{
       psh(x);
        x =R_string (x, 10);
        *(stack-1)=x;
        formR_japanese_aux ( x, 4 ,stream);
       pull();
   }
}

char * JLion[]={"", "万", "億", "兆", "京", "垓", "𥝱", "穣", "溝", "澗"};  //[10]

char *JCardinal_base[]={"", "一", "二", "三", "四", "五", "六", "七", "八", "九"}; //[10]

void formR_japanese_aux(ptr  x,int keta,ptr stream){
   int len,lion;
    len=STRLEN(x);
    lion= ( len- 1)/ keta;
      if (lion <10)       //(vector-size JLion)=10!!
          formR_japanese_aux_exe(  x, keta, stream, len, lion);
      else
         princ( x, stream);
     
}

char *jcardinal_base (ptr c);

void formR_japanese_aux_exe(ptr  x,int keta,ptr stream,int len,int lion){
      ptr in,c;
      int pos,code;
        pos= (len- 1)% keta;
         in= open_str( x,read_ac);
         c= read_char( in);
    while (c!=SEOF){
         code=CHAR_CODE(c);
       switch(pos){
          case 0: 
               pr_cstr(stream, jcardinal_base (c));
               pr_cstr(stream,JLion [lion] );
               lion--; 
               break;
          case 1:
              switch(code){
                   case '0': break;
                   case '1':
                        pr_cstr(stream, "十");
                        break;
                   default:
                        pr_cstr(stream, jcardinal_base (c));
                        pr_cstr(stream, "十");
                       break;
               }
                break;
           case 2:
              switch(code){
                   case '0': break;
                   case '1':
                        pr_cstr(stream, "百");
                        break;
                   default:
                        pr_cstr(stream, jcardinal_base (c));
                        pr_cstr(stream, "百");
                        break;
                 }
              break;

             case 3:
                 switch(code){
                   case '0': break;
                   case '1':
                        pr_cstr(stream, "千");
                        break;
                   default:
                        pr_cstr(stream, jcardinal_base (c));
                        pr_cstr(stream, "千");
                        break; 
                 }
              break;

              default:
                   break;  // Not appear
        }
      pos--;
      if (pos< 0) pos+=keta;
      c= read_char( in);
   }
}

char *jcardinal_base (ptr c){
  int s;
   s=CHAR_CODE(c)-'0';
      return JCardinal_base[ s];
}
/***   ~w,d,e,k,ovfchar,padc,expchar E   ***/
void formE(ptr x,ptr stream,ptr para,ptr mode)
 {
    /*** E-format ***/
    /***  89.7.20  scale factor support ***/
   int modeb,e,k;
     char *pr_E();
   int w,d,n,sig,expc;
   char *p;
   ptr pad_c;
   if(!REALP(x)){
       formAC(x,stream,para,mode);
       return;
   }
   f_init(x);
   w=para_num(para,0,0);
   d=para_num(para,1,yuuko-1);
       if(d<=0) d=1;
   modeb=GETNUM(mode);
   e=para_num(para,2,0);  // exp digits, 0 means Not bound and permit needed digits
   expc=para_char(para,6,'e');   //e+0
   k=para_num(para,3,1);   //scale    <k nonzero-digits. d digits>e+??   that is d+k=yuuko
   pad_c=para_pchar(para,5,char_space);
   if((p=pr_E(d,e,expc,k)))
    {
      sig=(*(p+1)=='0'&&*(p+3)!=expc);  /***  0.xxx   0 is syouryaku dekiru */
      if((*p=='+')&&(atto==0))
         p++;
      n=strlen(p);
      if(w)
       {
         if(n>w)
          {
            if(sig&&(--n==w))
             {
                 /***   0.1e+0 --->.1e+0  ***/
               if(*p++!='0')
                {
                  *p=*(p-1);
                }
             }
            else
               goto over;
          }
        pad(pad_c,w-n,stream);
       }
     owari:
      pr_cstr(stream,p);
     return;
    }
   over:
  /** 90.3.29 **/
       //sprintf(p=xf,f_format,f_val);
       prin_E(f_val,MAXK-1,p=xf);
     if((n=para_char(para,4,0)))
      {
        if(w==0) w=strlen(p);
          pad(MAKECHAR(n),w,stream);
      }
     else
      {
      goto owari;
      }
 }


char *pr_E(d,e,expc,k)
   Reg int d,e,expc,k;
 {
   Reg int n,dc,scale;
   Reg char *p,*q;
    /***  d=syousuubu-keta  e=sisuu-keta expc=exp-character(e,E,d,D...) ***/
    /*** k=scale   89.7.20***/
      /***   k,d no settei  ***/

     if(k>0)
      {
        d+=1-k;
      }
     else
       d+=k;
     if(d<0)
        {
          return NULL;   /*** parame-ta miss -->overflow to minasu! ***/
        }
     dc=d;
   if(dc>MAXK) dc=MAXK;
   d-=dc;
   p=xf;
   q=wf;
   *q++=*p++;  /*  +-  */
     scale=val_sisu-k+1;
  /***  n is  yuukou keta suu  ***/
  if(k>0)
     n=k+dc;   /*** xxx.sss = k.dc  ****/
  else
     n=dc;    /***  0.000ssss= 0.k*0 dc   ***/
   p=marume(n);
   if(*p++!='0')
    {   /***  all keta-agari ***/
       --p;
       scale++;
    }
  if(k>0)
   {
     while(k--)
        *q++=*p++;
           *q++='.';
    }
  else
   {
           *q++='0';
           *q++='.';
       while(k++)
           *q++='0';
   }
        while(dc--)
           *q++=*p++;
     while(d--)
       *q++='0';
   p=index(p,'e');
    /* strcpy(q,p); */
    *q++=expc;
     if(makesisu(q,e,scale))
      {
       return wf;
      }
     else
       return NULL;
 }
int makesisu(q,e,v)
  Reg char *q;
  Reg int e,v;  /* keta suu ,  value */
 {
  Reg char *r=sisu;
  Reg int n;
   *r='+';
   //sprintf(r+(v>=0),"%d",v);
   Prin_sint(v,10,r+(v>=0));
   *q++=*r++;
  if(e)
   {
     n=strlen(r);
      if(n>e) return NO;
        while(n++<e)
         *q++='0';
    }
   strcpy(q,r);
   return YES;
 }

/***  ~w,d,k,ovfchar,padc F***/

void formF(ptr x,ptr stream,ptr para,ptr mode)
 {
   ptr dd,pad_c;
    /*** F-format ***/
     char *pr_F();
   int modeb;
  int w,d,n,sig,k;
  char *p,*q;
    if(!REALP(x)){
       formAC(x,stream,para,mode);
       return;
   }
 
   f_init(x);
   modeb=GETNUM(mode); 
   w=para_num(para,0,0);
   k=para_num(para,2,0);
   pad_c=para_pchar(para,4,char_space);
   dd=para_ref(para,1);
   if(dd==a_f)
    {
      d=yuuko;
       n=val_sisu+1;
     if(d<n) d=n;
     d-=n;
     if(d==0) d=1; /** 91.8.8**/
    }
   else
      d=GETNUM(dd);
  /* if(d==0) d=1; */
  retry:
   p=pr_F(d,k);
    if(p==NULL)
     {
      p=wf+((*wf=='+')&&(atto==0));
      goto over;
     }
      sig=(*p=='+')&&(atto==0);
      if(sig)
         p++;
      n=strlen(p);
      if(w)
       {
         if(n>w)
         {
            if(dd!=a_f)
                 goto over;
             else
              {
                /*** 89.7.20   justification to w ***/
                 d-=(n-w);
                 if(d<=0) goto over;
                 goto retry;
             }
          }
        pad(pad_c,w-n,stream);
       }
      pr_cstr(stream,p);
     return;
   over:
      dd=para_ref(para,3);
     if(dd!=a_f)
      {
        /* if(w==0) w=strlen(p);*/
          pad(dd,w,stream);
      }
     else
      pr_cstr(stream,p);
 }

void formG_old(ptr x,ptr stream,ptr para,ptr mode)
 {
    /*** G-format ***/
   ptr p,wp,dp,res=a_nil;
   int modeb;
   int w,d,n,ww,e,ee,dd,q,omit_f;
  /** 89.7.23  changed ***/
   if(!REALP(x)){
       formAC(x,stream,para,mode);
       return;
   }
 
   f_init(x);
   modeb=GETNUM(mode);
   wp=para_ref(para,0);
   w=(wp==a_f)?0:GETNUM(wp);
   dp=para_ref(para,1);
   d=(dp==a_f)?0:GETNUM(dp);
   q=yuuko;
   n=val_sisu+1;
  /* printf("yuuko=%d n=%d\n",q,n);   */
  p=para_ref(para,2);
  if(p!=a_f){
      e=GETNUM(p);
      ee=e+2;
   }
  else
      ee=4;
   ww=w?w-ee:0;
  p=para_ref(para,1);
   if(p==a_f)
    {
       if(n>q) d=n;
       else
          d=q;
    }
      dd=d-n;
  /* printf("d=%d dd=%d\n",d,dd);   */
    if(dd<0||-3>n||n>7)
          goto Ek;
    if((wp!=a_f)&&(ww<((n>0)?d+2:dd+3)))
          goto Ek;
       if((dp==a_f)&&(dd<=0)) dd=1;
       if(nc_length(para)>4)
               res=CDR(CDR(CDR(CDR(para))));  //para[4],[5]
       res=CONS(a_f,res);
       res=SCONS(MAKESINT(dd),res);
       res=SCONS(MAKESINT(ww),res);
       psh(res);
       /***
       para[0]=ww;
       para[1]=dd;
       para[2]=UNGIVEN;
       para[3]=para[4];
       para[4]=para[5];
       ***/
       formF(x,stream,res,mode);
       pad(char_space,ee,stream);
       pull();
      return;
    Ek:
       /* para[1]=d; */
       formE(x,stream,para,mode);
 }
void formG(ptr x,ptr stream,ptr para,ptr mode)
 {
    /*** G-format ***/
   ptr p,wp,dp,res=a_nil;
   int modeb;
   int w,d,n,ww,e,ee,dd,q,omit_f,n7=7;
  /** 89.7.23  changed ***/
     if(!REALP(x)){
       formAC(x,stream,para,mode);
       return;
   }

   f_init(x);
   modeb=GETNUM(mode);
   wp=para_ref(para,0);
   w=(wp==a_f)?0:GETNUM(wp);
   dp=para_ref(para,1);
   d=(dp==a_f)?0:GETNUM(dp);
   q=yuuko;
   n=val_sisu+1;
  /* printf("yuuko=%d n=%d\n",q,n);   */
  p=para_ref(para,2);
  if(p!=a_f){
      e=GETNUM(p);
      ee=e+2;
   }
  else
      ee=4;
   ww=w?w-ee:0;
  //p=para_ref(para,1);
   if(dp==a_f)
    {
        if(n<7) n7=n;  //min n,7
       if(n7>q) d=n7;
       else
          d=q;
    }
      dd=d-n;
  /* printf("d=%d dd=%d\n",d,dd);   */
   if(dd<0||dd>d)
          goto Ek;
    //if((wp!=a_f)&&(ww<((n>0)?d+2:dd+3)))
      //    goto Ek;
       if((dp==a_f)&&(dd<=0)) dd=1;
       if(nc_length(para)>4)
               res=CDR(CDR(CDR(CDR(para))));  //para[4],[5]
       res=CONS(a_f,res);
       res=SCONS(MAKESINT(dd),res);
       res=SCONS(MAKESINT(ww),res);
       psh(res);
       /***
       para[0]=ww;
       para[1]=dd;
       para[2]=UNGIVEN;
       para[3]=para[4];
       para[4]=para[5];
       ***/
       formF(x,stream,res,mode);
       pad(char_space,ee,stream);
       pull();
      return;
    Ek:
       /* para[1]=d; */
       formE(x,stream,para,mode);
 }

/***  ~d,n,w,padc $***/

void formDC(ptr x,ptr stream,ptr para,ptr mode)
 {
   ptr dd,pad_c;
    /*** $-format ***/
     char *pr_F();
   int modeb;
  int w,d,n,sig,k,nketa,zero;
  char *p,*q;
    if(!REALP(x)){
       formAC(x,stream,para,mode);
       return;
   }

   f_init(x);
   modeb=GETNUM(mode);
   w=para_num(para,2,0);
   d=para_num(para,0,2);
   nketa=para_num(para,1,1);  // int part keta
   pad_c=para_pchar(para,3,char_space);

   p=pr_F(d,0);
    if(p==NULL)
     {
      p=wf+((*wf=='+')&&(atto==0));
      goto over;
     }
     if((modeb&1)==1){ //:
         if(atto||(*p=='-')){
             princ(MAKECHAR(*p),stream);  //sig  +,-
             p++;
             w--;
          }
         else
           p++;
      }
      else if((atto==0)&&(*p=='+'))
           p++;
      else
           ;
      n=strlen(p);
      sig=(*p=='-'||*p=='+');
      k=n-1-d-sig;
      zero=(k<nketa)?(nketa-k):0;
      n+=zero; 
      if(w&&(w>n))
       {
        pad(pad_c,w-n,stream);
       }
      if(zero>0){
        if(sig){
             princ(MAKECHAR(*p),stream);  //sig +, -
             p++;
        }
        pad(MAKECHAR('0'),zero,stream);
      }
   over:
      pr_cstr(stream,p);
     return;
 }

    
char *pr_F(d,e)
   Reg int d,e;
 {
   Reg int n,scale;
   Reg char *p,*q;
    /***  d=syousuubu-keta  e=scaling ***/
   p=xf;
   q=wf;
   *q++=*p++;  /*  +-  */
   scale=val_sisu+e+1;
   if(scale>80||scale<-80) 
     {
        /**** overflow ****/
       *q++=*p++; 
       *q++='.';
        while(--yuuko>0)
          *q++=*p++;
       *q++='E';
       if(--scale>=0) *q++='+';
       //sprintf(q,"%d",scale);
       Prin_sint(scale,10,q);
       return NULL; /**** overflow ****/
     }
  /***  n is  yuukou keta suu  ***/
     n=scale+d;   /*** xxx.sss = scale.dc  ****/
   if(n>=0) p=marume(n);
   if(*p++!='0')
    {   /***  all keta-agari ***/
       --p;
       scale++;
    }
   if(scale>0)
    {
        while(scale--)
          *q++=*p++;
        *q++='.';
        while(d--)
          *q++=*p++;
    }
   else
    {
     *q++='0';
     *q++='.';
     d+=scale;
      if(d<0)  /***  <= wo < nisita. 89.7.20 */
           q=zerot(q,d-scale);
      else 
       {
           q=zerot(q,-scale);
        while(d--)
          *q++=*p++;
       }
     }
    *q=0;
       return wf;
 }

char *zerot(q,d)
  Reg char *q;
  Reg int d;
 {
   while(d--)
     *q++='0';
   return q;
 }

int f_init(dp)
  Reg ptr dp;
  {
    Reg double x;
    Reg int n,sig;
     Reg char *p;
    /***   _float && ~A support ***/
    /*
    if(RATIOP(dp)) dp=_float(dp);
    else if(!DOUBLEP(dp)) return -9999;
    */
 //  _float(dp) see dbl.c,  real dp -> Dbl ptr
    x=get_float(dp);  
    f_val=x;
    if((sig=(x<0))) x=-x;
   //sprintf(xf,f_format,x);
   n=MAXK-1;
   prin_E(x,n,xf);
   p=xf+(++n);
   while(*p--=='0')
     n--;
   xf[1]=*xf;
   *xf=sig?'-':'+';
  /* printf("n=%d\n",n);   */
    p=xf+MAXK+2;   /***  sisuubu ****/
    val_sisu=atoi(p);
     yuuko=n;
    return n;
   }
/***
int f_init_set(dp)
  Reg ptr dp;
  {
    Reg double x;
    Reg int n,sig;
     Reg char *p;
     
     f_val=x=*(double *)dp;
    if((sig=(x<0))) x=-x;
   //sprintf(xf,f_format,x);   
   n=MAXK-1;
   p=xf+(++n);
   while(*p--=='0')
     n--;
   xf[1]=*xf;
   *xf=sig?'-':'+';
    p=xf+MAXK+2;   **  sisuubu **
    val_sisu=atoi(p);
   return yuuko=n;
  }
***/
  /* printf("n=%d\n",n);   */

char *marume(n)
  Reg int n;   /*** ketasuu   ***/
{
 /****   xf-->vf ***/
 /*****   031415   or 100000 (+999999)  **/
 /****   so *vf==0 is usual  ****/
   Reg int k,c;
   Reg char *p,*q;
   p=xf;
   q=vf;
   *q++='0';
   p++;  /** skip + ***/
   k=yuuko;
   if(n>=k)
   {
     while(k--)
       *q++=*p++;
     n-=k;
       while(n--)
           *q++='0';
   }
  else
   {
    while(n--)
           *q++=*p++;
        /***  4 sya 5 nyuuu!!!! ****/
     if(*p>'4')
      {
         while(*--q=='9')
            {
              *q='0';
            }
          *q+=1;
       }
    }
  return vf;
 }





