/*** 
  m_comp.c  03.12.20

  a little part of m-comp.ss
  see also comp.c
****/
#include "lisp.h"

extern ptr NOP,k_warn;
extern ptr k_load,k_set,k_warn,k_env,k_top,k_lambda,k_macro,k_func,k_tail_jump;
extern ptr k_define,k_jmp,k_label,k_block_out,k_block_in,k_BIND,k_letbind,k_stack_narg;
extern ptr k_lambda_begin,k_lambda_bind,k_IF,k_I,k_call_cc,k_F;
extern ptr k_jsr,k_exit,k_tail,k_frame,k_frame_list;
extern ptr k_lambda_end,k_macro_end,k_imm,k_alloc,k_dealloc,k_reg;
extern ptr k_undef,k_make_lambda,k_make_macro;

extern ptr list2(),insert_comp();

final_comp(ptr v){
 Reg  ptr *p,x,top,block,alloc,prev;
 int i,n,k,macro;

 p=get_vector(v,&n);
 i=0;
 while(i++<n){
  x=*p;
  top=CAR(x);
  if(top==k_lambda_begin){
      x=CDR(x);
      alloc=CAR(CDDR(CDR(x)));
      macro=(CADR(x)==k_macro);
      block=CAR(x);
      if(alloc!=ZERO)
          insert_comp(p+2,list2(k_alloc,alloc));
   }
  else if(top==k_lambda_end){
      x=CDR(x);
      block=CAR(x);
      macro=(CADR(x)==k_macro);
      prev=*(p-1);
      if(CAR(prev)!=k_exit){
          insert_comp(p,list2(k_exit,block));
          p++;
      }
     if(macro)
        macro=k_make_macro;
      else
        macro=k_make_lambda;
      *p=list2(macro,block);
     }
  else 
    ;
  p++;
 }
}

if_syori(ptr v){
 Reg  ptr *p,x,top;
 int n,i,k;
 p=get_vector(v,&n);
 i=0;
 while(i++<n){
  x=*p;
  top=CAR(x);
  if(top==k_IF||top==k_jmp){
      jmp_count(p,n-i);
   }
  if(top==k_lambda_begin){
      lambda_count(p,n-i);
  }
  p++;
 }
}

int lambda_count(ptr *p,int n){
 Reg  ptr op,x,top,lab;
 int i,k;
 op=*p++;
 lab=CADR(op);
 k=i=0;
 while(i++<n){
  x=*p++;
  top=CAR(x);
  if(top==k_make_lambda||top==k_make_macro){
     if(lab==CADR(x)){
      CAR(CDDR(op))=MAKESINT(k);
      CADR(x)=MAKESINT(k);
      break;
       }
   }
   k+=count_op(top,x);
 }
}

int jmp_count(ptr *p,int n){
 Reg  ptr op,x,top1,top,lab;
 int i,k;
 op=*p++;
 top1=CAR(op);
 if(top1==k_IF)
    lab=CADR(CDR(op));
 else
     lab=CADR(op);
 k=i=0;
 while(i++<n){
  x=*p++;
  top=CAR(x);
  if((top==k_label)&&(CADR(x)==lab)){
      if(top1==k_IF)
         CDR(CDDR(op))=MAKESINT(k);
      else
         CDDR(op)=MAKESINT(k);
      break;
   }
   k+=count_op(top,x);
 }
}
int  count_op(ptr op,ptr x){
  int n;
  if(op==k_label) n=0;
  else if(op==k_func) n=1;
  else if(op==k_block_in) n=1;
  else if(op==k_block_out) n=1;
  else if(op==k_exit) n=1;
  else if(op==k_lambda_bind) n=3;
  else if(op==k_stack_narg) n=1;
  else if(op==k_call_cc) n=1;
  else if(op==k_load){
     if(CONSP(CDDR(x)))
        n=2;
     else
        n=1;
   }
  else
    n=2;
 return n;
}   


