#|
    2004.3.17
    letdefine.ss
    (let-define->rec  form)
    Ȥ롣
       beginν
 define->letrec
     򤹤롣
     Thanks to Mr. S.Sugimoto
|#

;;;; let-syntax,letrec-syntax 
;;;   ֤
(in-package "macro")
(define *define-rec*
  (list 'lambda lambda 'let* let* 'letrec letrec)
)

#|     must last
(define (let-define->rec form)
  (if (pair? form)
      (define->rec form)
      form)
)
|#

(define (define->rec form)
  (let* ((top (car form)) (body (cdr form)))
    (if (memq top *define-rec*)
        (define-rec-sub top body)
        (if (syntax-special? top)
            (define-rec-special top body)
           ;;; function call
            (define-rec-args top body)
        )
    )
))

(define (define-rec-sub top body)
  (let ((def ()) (f 0)(res ()) (args (car body)) )
    (set! body(cdr body))
    (set! body (begin-open body))
    (if (not (or (eq? top lambda)(eq? top 'lambda)))
       (begin
        ;;;(format #t "args ~s ~s~%" top args)
        (set! args (define-letargs args))
       )
    )
    (while (pair? body)
       (set! f (car body))
       (set! res body)
       (if  (define-form? f)
            (begin
              (set! def (cons f def))
              (set! body (cdr body))
             )
            (begin
              (set! body ())
            )
        )
    )
   (if (pair? def)
       (def->letrec top args def res)
       (cons top (define-rec-args args res))
   )
))

(define (begin-open body)
  (let ((f 0)(res ())(tmp ()) )
    (while (pair? body)
      (set! f (car body))
      (if (begin-form? f)
         (begin
           (set! tmp (cdr f))
           (while (pair? tmp)
             (set! res (cons (car tmp) res))
             (set! tmp (cdr tmp))
           )
          )
         (set! res (cons f res))
      )
     (set! body (cdr body))
   )
   (reverse res)
))

(define (def->letrec top args def body)
   (let ((res ())(f 0))
     (while (pair? def)
       (set! f (car def))
       (set! res (cons (list (cadr f)
            (let-define->rec (caddr f))) res))
       (set! def (cdr def))
     )
    (set! res (cons 'letrec (define-rec-args res body)))
    (list top args res)
))

(define (define-rec-args top body)
   (let ((res ())(f 0))
     (while (pair? body)
       (set! f (car body))
       (set! res (cons (let-define->rec f) res))
       (set! body(cdr body))
     )
    (cons top (reverse res))
))

(define (begin-form? f)
   (and (pair? f)
      (or (eq? (car f) 'begin)(eq? (car f) begin)))
)

(define (define-form? f)
   (and (pair? f)
      (or (eq? (car f) 'define)(eq? (car f) define)))
)

(define (define-rec-special top body)
  (if (or (eq? top 'quote) (eq? top quote))
        (cons top body)
       (define-rec-args top body)
  )
)

;;; expand  let arg
(define (define-letargs args)
   (let ((res ())(f 0))
     (while (pair? args)
       (set! f (car args))
       (set! res (cons (list (car f) (let-define->rec (cadr f))) res))
       (set! args(cdr args))
     )
    (reverse res)
))

;;;;  this must locate last!
(define (let-define->rec form)
  (if (pair? form)
      (define->rec form)
      form)
)
                    
        

