;;;2010.8.3
;;;
(in-package "macro")

(define (identifier? x) (or (symbol? x)(syntax-symbol? x)))

(define (syntax-object->datum x)
   (cond ((pair? x)
            (cons (syntax-object->datum  (car x)) 
                  (syntax-object->datum  (cdr x)))   ) 
         ( (syntax-obj? x)
            (if (syntax-lambda? x)
                   x
                 (object->datum (<-syntax x))  )) 
         (else x)
    )
)

(define (object->datum x)
     x   ;;;;  toriaezu 
)

(define (syntax-equal? x y)
   (and (equal? (syntax-car x) (syntax-car y))
    (equal? (syntax-cdr x) (syntax-cdr y)))
)
;;; P.196
(define-syntax with-syntax
  (lambda (x)
     (syntax-case x ()
       ((_ ((p e0) ...) e1 e2 ...)
          (syntax (syntax-case (list e0 ...) ()
                    ((p ...) (begin e1 e2 ...))))))))


(export '(identifier? syntax-object->datum object->datum syntax-equal? with-syntax))

#| check   Not work!  8.26
 (with-syntax ((rest  (fact 10)))
      rest)


(define-syntax OR
   (lambda(x)
      (syntax-case x ()
        ((_) (syntax #f))
        ((_ x) (syntax x))
        ((_ x y z ...) 
           (with-syntax ((rest (syntax (OR y z ...))))
                 (syntax (let ((t x)) (if t t rest))))   ))))
|#

