(in-package "macro")

(define (syntax-ex f )
  (if (pair? f)
        (syntax-ex-pair f)
      (begin   ;;; allow symbol-transformer see P.193
         (if (symbol? f)
           (let* (( x (macro? f)))
              (if x
                 (begin
                   (format #t "singlton macro:~s ~s~%" f x)
                   (sys-eval (list x (list quote f)) *local-env*)
                 )
                 f
              )
           )
            f
         )
      )
  )
)

