;;;;  SRFI functions
;;; srfi-6
(define (get-output-string out)
   (if (output-port? out)
      (string-copy (port-string out))
      (error E_notstream out)
   )
)
;;; srfi-8
(define-syntax receive
    (syntax-rules ()
      ((receive formals expression body ...)
          (call-with-values (lambda () expression) 
                (lambda formals body ...))
      )
   )
)
;;;

