;;;  vm-makesr.ss
;;;;


(load "vm-op-table.ss")
;;(load "vm-compiler")
;;(load "vm-list-final")
(load "vm.ss")

(define (make-name-sr2 file)
   (let* ((s (split-string file ".")))
     (tk-string (car s) ".sr2")
  )
)

(define (compile-file file)
   (let* ((sr  (make-name-sr2 file)))
      (makesr2 file)
      (rename-file  "aout.sr2" sr)
   )
)

(define   (makesr2 file)
   (let* ((in (open-input-file file)) (x (read in)) ;;;;(pcst PCST)
           (out (open-output-file "aout.sr2")) )
       (format out "~s~%" 'BEGIN-SR2)
     (while (not (eof-object? x))
          (format #t "~s~%" x)
         (set! x (macro-expand-rec x ()))
         ;;;(let* ((genv GENV) (env ENV))
         (let* ( (env ENV))
            (set! x (Compile x))
            ;;;(set! x (c-opt x))    ;;;;  optimize
            (set! x (final x))   ;;;; use final
            ;;;(set! GENV genv)
            (set! ENV env)
         )
     ;;;;; (set! PCST ())
      ;;;  (VM x ())
        ;;;;(VM x )
       (set! x (trans-num x))
       (format out "~s~%" x)
       (set! x (read in))
    )
       ;;;;(format out "~s~%" 'END-SR2)
   (close-port in)
   (close-port out)
   (format #t "makesr2  ~s END~%" out)
   ;;;;(set! PCST pcst)
))

(if (pair? *argv*)
  (while (pair? *argv*)
     (compile-file (car *argv*))
     (set! *argv* (cdr *argv*))
  )
  (let* ((s (glob-file "*.ss")) (f 0)(fr 0))
    (while (pair? s)
       (set! f (pop s))
       (set! fr (string-append (substring f 0 :end -2) "sr2"))
       (if (file-exists? fr)
           (if (> (file-time fr)(file-time f)) (set! f #f))
       )
       (when f (format #t "Compile ~s~%" f) (compile-file f))
    )
   )
)
   
(bye)

