;;;TSP 
;;; 04.1.29
;;;
(define MC 2)
(define CM 0)
(define MS 8)
(define TC 0)
(define ST 0)   ;;;; step 
(define CT 0)   ;;;;  
(define T 0)
(define N 0)
(define NM 0)
(define P 0)
(define SG 0)
(define H 1)
(define HL 0)
(define ES (+ MS 1))
(define ES2 (+ MS 2))
(define X (make-vector ES2 0))
(define DX (make-vector ES2 0))
(define C (make-matrix ES ES 0.0))

(do ((i 1 (+ i 1))(r 0))
    ((= i 1000))
    (set! r (random))
)

(define (int-floor x)
   (inexact->exact (floor x))
)

(do ((k 2 (+ k 1)))
       ((> k MS))
  (do ((l 1 (+ l 1)))
      ((> l (- k 1)))
      (matrix-set! C k l (+ (* 3 (int-floor (* 3 (random))))(random)))
     )
)


(do ((k 1 (+ k 1)))
    ((> k (- MS 1)))
  (do ((l (+ k 1) (+ l 1)))
      ((> l MS))
      (matrix-set! C k l (matrix-ref C l k))
  )
)

(do ((k 1 (+ k 1)))
    ((> k MS))
    (let ((x 0)(y 0))
    (do ((l 1 (+ l 1)))
        ((> l MS))
	(set! y (abs (matrix-ref C k l)))
	(if (> y x)
	    (set! x y))
    )
        (set! TC (+ TC x))
))

(do ((k 1 (+ k 1)))
    ((> k MS))
    (vector-set! X k k)
)
    (vector-set! X 0 (vector-ref X MS))
    (vector-set! X ES (vector-ref X 1))
    (set! CM 0)
   (do ((k 1 (+ k 1)))
       ((> k MS))
       (set! CM (+ (matrix-ref C (vector-ref X k) (vector-ref X (+ k 1))) CM))
   )
   (do ((k 0 (+ k 1)))
       ((> k ES))
       (vector-set! DX k (vector-ref X k))
   )

;;;main
(define (start)
(let ((i 0)(j 0)(x 0))
    (set! SG 0)
    (set! H 1)
     (if (> TC 5)
         (set! TC 5)
     )
     (while (> H 0)
            (set! H 0)
          (set! NM 0)
        (do ()
	    ((> NM (- MC 1)))
	    (set! T (/ TC (log (+ (* MC SG) NM 2))))
            (set! N 1)
          (do ()
	      ((> N MS))
              (set! HL 0)
	      (set! i (+ (int-floor (* MS (random))) 1))
	      (if (> i MS)
	          (set! i MS)
              )
	      (set! j i)
	      (while (= j i)
	         (set! j (+ (int-floor (* MS (random))) 1))
		 (if (> j MS)
		     (set! j MS)
		 )
              )
              (set! x (matrix-ref C (vector-ref X (- i 1)) (vector-ref X j)))
	      (set! x (+ x (matrix-ref C (vector-ref X i) (vector-ref X (+ j 1)))))
	      (set! x (- x (matrix-ref C (vector-ref X (- i 1)) (vector-ref X i))))
	      (set! x (- x (matrix-ref C (vector-ref X j) (vector-ref X (+ j 1)))))
	      (if (<= x 0)
	          (set! HL 1)
		  (askchange x)
              )
	      (if (= HL 1)
	          (change i j)
              )
              (set! CT 0)
             (do ((k 1 (+ k 1)))
	         ((> k MS))
	         (set! CT (+ CT (matrix-ref C (vector-ref X k) (vector-ref X (+ k 1)))))
             )
	     (if (< CT CM)
	         (minset )
	     )
	     (if (= HL 1)
	         (hyoujidta)
	         (hyoujihl i j )
	     )
	     (if (= HL 1)
	         (set! H 1)
	     )
            (set! N (+ 1 N))
          )
          (set! NM (+ 1 NM))
        )
	(if (= HL 1)
	    (set! H 1)
	)
	(set! SG (+ SG 1))
     )
)
)
(define (askchange x)
      (set! P (exp (/ (- x) T)))
      (if (< (random) P)
          (set! HL 1)
      )
)

(define (change i j)
      (if (< i j)
          (change1 i j)
	  (change2 i j)
      )
)

(define (change1 i j)
   (let ((p 0) (q 0) (r 0) (s 0) (XT 0))
        (set! p (quotient (- j i 1) 2))
        ;;;(format #t "change1 in ~s ~s  p ~s ~%" i j p)
     (do ((q 0 (+ q 1)))
         ((> q p))    ;;;;   ????  org is >
	 (set! r (+ i q))
	 (set! s (- j q))
	 (set! XT (vector-ref X r))
	 (vector-set! X r (vector-ref X s))
	 (vector-set! X s XT)
    )
    (vector-set! X 0 (vector-ref X MS))
    (vector-set! X ES (vector-ref X 1))
       ;;; (format #t "change1 out ~s  ~s  p ~s ~%" i j p)
  )
)

(define (change2 i j)
   (let ((p 0) (q 0) (r 0) (s 0) (XT 0))
       ;;; (format #t "change2 in ~s ~s ~%" i j)
        (set! p (+ MS  j (- i) -1))
	(set! p (quotient p 2))
       ;;; (format #t "change2 in ~s ~s  p ~s ~%" i j p)
     (do ((q 0 (+ q 1)))
         ((>  q p))      ;;;;;;;;????  org  is  >
	 (set! r (+ i q))
	 (if (> r MS)
	     (set! r (- r MS))
	 )
	 (set! s (- j q))
	 (if (<= s 0)
	     (set! s (+ s MS))
	 )
         ;;;;(if (> s MS) (set! s (- s MS)))   ;;;; ?????   org is none
	 (set! XT (vector-ref X r))
	 (vector-set! X r (vector-ref X s))
	 (vector-set! X s XT)
     )
     (vector-set! X 0 (vector-ref X MS))
     (vector-set! X ES (vector-ref X 1))
       ;;; (format #t "change2 out ~s ~s ~%" i j)
   )
)

(define (minset)
    (let ((g 0) (m 0) (l 0) )
    (set! CM CT)
   (do ((k 0 (+ k 1)))
        ((> k ES))
	(vector-set! DX k (vector-ref X k))
    )
    (set! g SG)
    (set! m NM)
    (set! l N)
    (set! ST (+ (* (+ (* g MC) m) 2 MS) l))
    (format #t "current minimum = ~s~%" CM)
    (format #t "at ~s step" ST)
    (do ((k 1 (+ k 1)))
        ((> k MS))
	(format #t "~s-" (vector-ref DX k))
    )
)
)

(define (hyoujidta )
    (format #t "curret cost = ~s~%" CT)
    (set! ST (+ (* (+ (* SG MC) NM) MS) N))
    (format #t "at ~s step" ST)
)

(define (hyoujihl i j )
    (format #t "HL= ~s " HL)
    (format #t "( ~s" i ", ~s )" j)
    (format #t "T= ~s~%" T)
    (format #t "P= ~s~%" P)
)
(start)
